% ------------------------------------------------------------------------------
% Copyright (c) 2019, 2025 Contributors to the Eclipse Foundation
%
% See the NOTICE file(s) distributed with this work for additional
% information regarding copyright ownership.
%
% This program and the accompanying materials are made available under the terms
% of the MIT License which is available at https://opensource.org/licenses/MIT
%
% SPDX-License-Identifier: MIT
% ------------------------------------------------------------------------------
\documentclass{article}
\usepackage{tikz}
\usetikzlibrary{arrows.meta, arrows, automata, calc, positioning, shapes, shapes.misc}
\usepackage[paperwidth=40in, paperheight=20in]{geometry}

\begin{document}
\pagestyle{empty}

\begin{tikzpicture}[
    auto,
    ->,
    node distance=4cm,
    every state/.style={ellipse, semithick, fill=black!5, minimum size=1.5cm, font=\Large},
    initial distance=1.2cm,
    every initial by arrow/.style={-{Stealth[scale=1.4]}},
    initial text=,
    transform shape,
    double distance=2pt,
    every loop/.style={min distance=10mm}
]

\node[state, initial, accepting] (A) {\emph{1}};
\node[state, right=3cm of A]     (B) {\emph{2}};

\path[-{Stealth[scale=1.4]}]
    (B) edge[loop above, dashed]              node[align=center] {\texttt{push\_start}}                      (B)
    (A) edge[loop above, dashed]              node[align=center] {\texttt{push\_stop}}                       (A)
    (A) edge[bend left, above, dashed]        node[align=center] {\texttt{push\_start}}                      (B)
    (B) edge[bend left, below, dashed]        node[align=center] {\texttt{push\_stop}}                       (A)
;

\end{tikzpicture}
\end{document}
